﻿/*     Cadenus CHURN
       by Michael J. Cowan 2008 - 2009.
       
    */

 #include <algorithm>
 #include <vector>
 #include <iostream>
 #include <condefs.h>
 #include <conio.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <fstream.h>

  char code[4000],codex[500],plain[500],decode[4000],grid[30][15], new_grid[30][15];
  char pl_grid[30][15];
  short  b[26][26][26][26];
  int sh[15],c[20],key[20],order[20],master[20];
  int gene[60000][15],genoscore[60000],pop,child[20];
  int len,j,k,m,p,q,r,s,t,x,y,z,total;
  int first,second,third,fourth,score,max_score,flag,nr,nok,repeat;
  int noc,nor,row,index,col,maxscore,bestscore,nork;
  int start_row[20],shift[20];
  int sols,tot,nof;
  char primus,secundus,terts,quarts,letter[6];
  float leng,factor;

    int value[1000] = {0,0,0,0,0,0,0,1,1,1,1,1,1,1,2,2,2,2,2,2,2,3,3,3,3,4,4,4,4,4,4,4,5,5,5,5,5,6,6,6,
    6,6,7,7,8,8,8,8,9,9,9,9,9,10,10,10,10,11,11,11,11,12,12,13,13,14,14,15,15,15,15,
    16,16,17,17,18,18,19,20,20,21,22,22,23,24,25,26,27,28,29,30,32,33,36,38,40,42,47,56};

  int calc,vect;

  void make_grid(void);
  void randomise_key(void);
  void decrypt(void);
  void get_score(void);
  void filer(void);

  FILE *InFile;

 int main()
 {
   int p1,p2,m1,m2,bad,limit,buff,mike,n,buff_col,buff_shift;

  strcpy(codex,"MHDNE ARNTU NARBO OYBHN NAIAO TYTTI NEDIT HBLIE NREEO WTDFE RIEATNSAIB HENOC NNALE TEOEF IEATA NRGNC ETATU GUMBH ELDCW SIIND EONRSEPHAT IUOHE UDEPE MTLIA TAWEN DDBNE BIALG SISDR SAORL IPEOL TETAAEEDLH YDIOA MYEEB ADHEH INNTH AFHNL HITTM NWINR GSAOV NREAN HAKCOGEEHD ONENM RATBD RTLIE ROGTS SEICE");   // MJ 02, AC680  solves

  len=strlen(codex);

  t=-1;
  for(j=0;j<len;j++)
   if(codex[j]>32)
    {t++; code[t]=codex[j]; }


  len=strlen(code);  noc=len/25; nor=len/noc; limit=noc*noc;
  leng=len;factor=110/leng;
  cout<<"length="<<len<<"  No cols="<<noc<<"  No rows="<< nor<<" factor="<<factor<<endl;

   InFile = fopen( "C:\\archive source\\TetraLog_hank.bin", "rb" );

  fread( b, 2, 456976, InFile );  // read 456976 values, 2 bytes per value, into array a[][][][] from InFile
  fclose( InFile );
  cout<<"Hank's tetragraphs loaded...."<<endl;

  make_grid();  // 1st col is #0, last is noc-1
  randomize();
  repeat=1;  nork=0; mike=1;
   do{
       randomise_key(); // gets c[] as integers 0 to noc-1
       for(m=0;m<10;m++) {shift[m]=0; start_row[m]=0;}
       nork++;
       decrypt();
       get_score();

       maxscore=score;
       do{
          z=random(10);
          if(z<2)   // swap two columns at random
            {
             x=random(noc);
             do{ y=random(noc); }while(x==y);
             buff=c[x];c[x]=c[y];c[y]=buff;
             decrypt();
             get_score();
             vect=random(100);
             calc=maxscore-value[vect];
             if(score>calc)
                { maxscore=score; bad=0; }
             else
                {
                 bad++;
                 buff=c[x];c[x]=c[y];c[y]=buff;
                }
            }
          else   // randomly choose a column & change the shift
            {
             x=random(noc); // choose a column
             buff_col=x;
             do{ y=random(24)+1; }while (y==shift[x]); // get a new shift
             shift[x]=y;  buff_shift=y;
             start_row[x]=start_row[x]+shift[x];
             if(start_row[x]>24) start_row[x]-=25;
             decrypt();
             get_score();
             vect=random(100);
             calc=maxscore-value[vect];
             if(score>calc)

                { maxscore=score; bad=0; }
             else
                {
                 bad++;
                 start_row[buff_col]-=buff_shift;
                 if(start_row[buff_col]<0)  start_row[buff_col]+=25;
                }
            }


           if(bad>500) break;
         }while(repeat>0);

     }while(mike>0);

  cout<<endl;
  cout<<"end";
  getch();
  return 0;
  }

 /*------------------------------------------------------------------------*/

  void decrypt(void)
    {
       int m,target,mini,x,y;
       //...find ascending order....
       t=-1;
       for(target=0;target<26;target++)
         for(m=0;m<noc;m++) if(c[m]==target) { t++; order[m]=t;}



       //...adjust vertical position....
       for(m=0;m<noc;m++) // indices 0 to noc-1
         {
          //cout<<"col="<<m<<" start row+shift="<<x<<"  ";
          for(row=0;row<25;row++)
            {
             y=start_row[m]+row;
             if(y>24) y=y-25;
             new_grid[row][m]=grid[y][m];

            }
         }


   //...adjust horizontal position...
     for(m=0;m<noc;m++)
        for(row=0;row<25;row++)
         pl_grid[row][order[m]]=new_grid[row][m];
     t=-1;
     for(row=0;row<25;row++)
       for(col=0;col<noc;col++)
         {t++; plain[t]=pl_grid[row][col];}

    }

  void get_score(void)
    {
      int plainex[1000],m;

      nok++;
      if(nok%1000000==0) cout<<nok<<"  ";
      for(m=0;m<len;m++) plainex[m]=plain[m]-65;
      score=0;
      for(m=0;m<len-3;m++)
       score=score+b[plainex[m]][plainex[m+1]][plainex[m+2]][plainex[m+3]];
      score=score*factor;

      if(score>bestscore)
         {


             cout<<"nok="<<nok<<" nork="<<nork<<" score="<<score<<"  ";
             cout<<"start_row = "; for(m=0;m<noc;m++) cout<<start_row[m]<<" "; cout<<endl;
              cout<<"order= "; for(m=0;m<noc;m++) cout<<order[m]<<" "; cout<<endl;
              for(p=0;p<len;p++) {primus=plain[p]+32; cout<<primus;} cout<<endl<<endl;

          bestscore=score;
         }
    }

  void make_grid(void)
   {

   t=-1;
   for(row=0;row<nor;row++)
    for(col=0;col<noc;col++)
      { t++; grid[row][col]=code[t]; }

  }
 

  void randomise_key(void)

 {
  flag=0;
  for(j=0;j<noc;j++)
    c[j]=99;


   for(j=0;j<noc;j++)
     {
       x=random(26);       // random #s 0 to noc-1

       for (k=0;k<noc;k++)
           if (c[k]==x)
             flag=1;
        if (flag==1)
           {j--;
            flag=0;
            }
        else
         {c[j]=x;

          }
     }//end for

 }



